package testComSighUtils;

import com.sigh.utils.strings.c_functions.*;


public class TestComSighUtils {
    
    public TestComSighUtils() {
    }

    public boolean canBeMadeAShort ( Double aValue ) {
        boolean retStatus = false;
        try {
            retStatus = (    (Double.valueOf(Short.MIN_VALUE) <= aValue )
                          && (Double.valueOf(Short.MAX_VALUE) >= aValue ) );
        } catch ( NumberFormatException nfE ) {
            System.out.println ( "Cannot be made a Short" );
            return false;
        }

        return retStatus;
    }

    public boolean canBeMadeAnInt ( Double aValue ) {
        boolean retStatus = false;
        try {
            retStatus = (    (Double.valueOf(Integer.MIN_VALUE) <= aValue )
                          && (Double.valueOf(Integer.MAX_VALUE) >= aValue ) );
        } catch ( NumberFormatException nfE ) {
            System.out.println ( "Cannot be made an Integer" );
            return false;
        }

        return retStatus;
    }

    public boolean canBeMadeALong ( Double aValue ) {
        boolean retStatus = false;
        try {
            retStatus = (    (Double.valueOf(Long.MIN_VALUE) <= aValue )
                          && (Double.valueOf(Long.MAX_VALUE) >= aValue ) );
        } catch ( NumberFormatException nfE ) {
            System.out.println ( "Cannot be made a Long" );
            return false;
        }

        return retStatus;
    }

    public boolean canBeMadeAFloat ( Double aValue ) {
        boolean retStatus = false;
        try {
            retStatus = (    (Double.valueOf(Float.MIN_VALUE) <= Math.abs(aValue) )
                          && (Double.valueOf(Float.MAX_VALUE) >= Math.abs(aValue) ) );
        } catch ( NumberFormatException nfE ) {
            System.out.println ( "Cannot be made a Float" );
            return false;
        }

        return retStatus;
    }

    public boolean canBeMadeAByte ( Double aValue ) {
        boolean retStatus = false;
        try {
            retStatus = (    (Double.valueOf(Byte.MIN_VALUE) <= aValue )
                          && (Double.valueOf(Byte.MAX_VALUE) >= aValue ) );
        } catch ( NumberFormatException nfE ) {
            System.out.println ( "Cannot be made a Byte" );
            return false;
        }
        return retStatus;
    }

    public static void main ( String[] argv ) {
        String formatString = " as %s from %s";
        Object[] values = new Object [ 3 ];
        TestComSighUtils tcsu = new TestComSighUtils();
        int i = 0;

        try {
            for ( i = 0; i < argv.length; ++i ) {
                double aValue = Double.valueOf ( argv [ i ] );
                if ( 0 > argv [ i ].indexOf ( '.' ) ) {
                    formatString = "%8d as %s from %s";
                    if ( tcsu.canBeMadeAByte(aValue) ) {
                        values [ 0 ] = Byte.valueOf ( argv [ i ] );
                        values [ 1 ] = "Byte";
                    } else if ( tcsu.canBeMadeAShort(aValue) ) {
                        values [ 0 ] = Short.valueOf( argv [ i ] );
                        values [ 1 ] = "Short";
                    } else {
                        formatString = "%6ld as %s from %s";
                        if ( tcsu.canBeMadeAnInt(aValue) ) {
                            values [ 0 ] = Integer.valueOf( argv [ i ] );
                            values [ 1 ] = "Integer";
                        } else if ( tcsu.canBeMadeALong(aValue) ) {
                            values [ 0 ] = Long.valueOf( argv [ i ] );
                            values [ 1 ] = "Long";
                        }
                    }
                } else {
                    formatString = "%10.2f as %s from %s";
                    if ( tcsu.canBeMadeAFloat(aValue) ) {
                        values [ 0 ] = Float.valueOf( argv [ i ] );
                        values [ 1 ] = "Float";
                    } else {
                        values [ 0 ] = aValue;
                        values [ 1 ] = "Double";
                    }
                }
                values [ 2 ] = argv [ i ];
                System.out.println ( Csprintf.sprintf(formatString, values) );
            } // end for
        } catch ( NumberFormatException nfE ) {
            System.out.println ( "Cannot convert argument " + i + " : " + argv [ i ] + " to a number." );
            System.out.println ( nfE.getMessage() );
            nfE.printStackTrace();
        } catch ( CsprintfExceptions csfE ) {
            csfE.printStackTrace();
        }
    }
}